package test;

import java.io.IOException;
import java.util.Arrays;
import java.util.List;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.annotation.WebInitParam;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@WebFilter(filterName="IPAddressFilter",urlPatterns={"*"},initParams={@WebInitParam(name="block",value="192.168.1.108,192.168.1.110")})
public class IPAddressFilter implements Filter {
    private List<String> blockaddr;
    @Override
    public void init(FilterConfig conf) throws ServletException {
        String allipaddr = conf.getInitParameter("block");
        blockaddr = Arrays.asList(allipaddr.split(","));
    }
    @Override
    public void doFilter(ServletRequest req, ServletResponse resp, FilterChain chain) throws IOException, ServletException {
        HttpServletRequest httpreq = (HttpServletRequest)req;
        HttpServletResponse httpresp = (HttpServletResponse)resp;
        String thisaddr = req.getRemoteAddr();
        if(blockaddr.contains(thisaddr)) {
            httpresp.setStatus(HttpServletResponse.SC_FORBIDDEN);
        } else {
            chain.doFilter(httpreq, httpresp);
        }
    }
    @Override
    public void destroy() {
    }
}
